package org.antlr.analysis;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import org.antlr.analysis.Label;
import org.antlr.analysis.SemanticContext;
import org.antlr.tool.Grammar;
import org.antlr.tool.GrammarAST;

public class PredicateLabel extends Label {
  protected SemanticContext semanticContext;
  
  public PredicateLabel(GrammarAST predicateASTNode) {
    super(-4);
    this.semanticContext = new SemanticContext.Predicate(predicateASTNode);
  }
  
  public PredicateLabel(SemanticContext semCtx) {
    super(-4);
    this.semanticContext = semCtx;
  }
  
  public int hashCode() {
    return this.semanticContext.hashCode();
  }
  
  public boolean equals(Object o) {
    if (o == null)
      return false; 
    if (this == o)
      return true; 
    if (!(o instanceof org.antlr.analysis.PredicateLabel))
      return false; 
    return this.semanticContext.equals(((org.antlr.analysis.PredicateLabel)o).semanticContext);
  }
  
  public boolean isSemanticPredicate() {
    return true;
  }
  
  public SemanticContext getSemanticContext() {
    return this.semanticContext;
  }
  
  public String toString() {
    return "{" + this.semanticContext + "}?";
  }
  
  public String toString(Grammar g) {
    return toString();
  }
}
